/*----- PROTECTED REGION ID(Mks651dClass.h) ENABLED START -----*/
//=============================================================================
//
// file :        Mks651dClass.h
//
// description : Include for the Mks651dClass root class.
//               This class is the singleton class for.
//               the Mks651d device class..
//               It contains all properties and methods which the .
//               Mks651d requires only once e.g. the commands.
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef MKS651DCLASS_H
#define MKS651DCLASS_H

#include <tango.h>
#include <Mks651d.h>

/*----- PROTECTED REGION END -----*/

namespace Mks651d_ns
{
	/*----- PROTECTED REGION ID(Mks651d::classes for dynamic creation) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	Mks651d::classes for dynamic creation



//=========================================
//	Define classes for attributes
//=========================================
//	Attribute Pressure class definition
class PressureAttrib: public Tango::Attr
{
public:
	PressureAttrib():Attr("Pressure",
	                   Tango::DEV_DOUBLE, Tango::READ) {};
	~PressureAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Mks651d *>(dev))->read_Pressure(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Mks651d *>(dev))->is_Pressure_allowed(ty);}
};

//	Attribute Position class definition
class PositionAttrib: public Tango::Attr
{
public:
	PositionAttrib():Attr("Position",
	                   Tango::DEV_DOUBLE, Tango::READ) {};
	~PositionAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Mks651d *>(dev))->read_Position(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Mks651d *>(dev))->is_Position_allowed(ty);}
};

//	Attribute ControlType class definition
class ControlTypeAttrib: public Tango::Attr
{
public:
	ControlTypeAttrib():Attr("ControlType",
	                   Tango::DEV_SHORT, Tango::READ_WRITE) {};
	~ControlTypeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Mks651d *>(dev))->read_ControlType(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Mks651d *>(dev))->write_ControlType(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Mks651d *>(dev))->is_ControlType_allowed(ty);}
};

//	Attribute SensorType class definition
class SensorTypeAttrib: public Tango::Attr
{
public:
	SensorTypeAttrib():Attr("SensorType",
	                   Tango::DEV_SHORT, Tango::READ_WRITE) {};
	~SensorTypeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Mks651d *>(dev))->read_SensorType(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Mks651d *>(dev))->write_SensorType(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Mks651d *>(dev))->is_SensorType_allowed(ty);}
};

//	Attribute SensorVoltage class definition
class SensorVoltageAttrib: public Tango::Attr
{
public:
	SensorVoltageAttrib():Attr("SensorVoltage",
	                   Tango::DEV_SHORT, Tango::READ_WRITE) {};
	~SensorVoltageAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Mks651d *>(dev))->read_SensorVoltage(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Mks651d *>(dev))->write_SensorVoltage(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Mks651d *>(dev))->is_SensorVoltage_allowed(ty);}
};

//	Attribute SensorRange class definition
class SensorRangeAttrib: public Tango::Attr
{
public:
	SensorRangeAttrib():Attr("SensorRange",
	                   Tango::DEV_SHORT, Tango::READ_WRITE) {};
	~SensorRangeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Mks651d *>(dev))->read_SensorRange(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Mks651d *>(dev))->write_SensorRange(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Mks651d *>(dev))->is_SensorRange_allowed(ty);}
};

//	Attribute ControlMode class definition
class ControlModeAttrib: public Tango::Attr
{
public:
	ControlModeAttrib():Attr("ControlMode",
	                   Tango::DEV_SHORT, Tango::READ_WRITE) {};
	~ControlModeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Mks651d *>(dev))->read_ControlMode(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Mks651d *>(dev))->write_ControlMode(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Mks651d *>(dev))->is_ControlMode_allowed(ty);}
};

//	Attribute ValveType class definition
class ValveTypeAttrib: public Tango::Attr
{
public:
	ValveTypeAttrib():Attr("ValveType",
	                   Tango::DEV_SHORT, Tango::READ) {};
	~ValveTypeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Mks651d *>(dev))->read_ValveType(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Mks651d *>(dev))->is_ValveType_allowed(ty);}
};

//	Attribute AnalogSPRange class definition
class AnalogSPRangeAttrib: public Tango::Attr
{
public:
	AnalogSPRangeAttrib():Attr("AnalogSPRange",
	                   Tango::DEV_SHORT, Tango::READ_WRITE) {};
	~AnalogSPRangeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Mks651d *>(dev))->read_AnalogSPRange(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Mks651d *>(dev))->write_AnalogSPRange(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Mks651d *>(dev))->is_AnalogSPRange_allowed(ty);}
};

//	Attribute SelectedSP class definition
class SelectedSPAttrib: public Tango::Attr
{
public:
	SelectedSPAttrib():Attr("SelectedSP",
	                   Tango::DEV_SHORT, Tango::READ) {};
	~SelectedSPAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Mks651d *>(dev))->read_SelectedSP(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Mks651d *>(dev))->is_SelectedSP_allowed(ty);}
};

//	Attribute PowerFailResponse class definition
class PowerFailResponseAttrib: public Tango::Attr
{
public:
	PowerFailResponseAttrib():Attr("PowerFailResponse",
	                   Tango::DEV_SHORT, Tango::READ_WRITE) {};
	~PowerFailResponseAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Mks651d *>(dev))->read_PowerFailResponse(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Mks651d *>(dev))->write_PowerFailResponse(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Mks651d *>(dev))->is_PowerFailResponse_allowed(ty);}
};





//=========================================
//	Define classes for commands
//=========================================
//	Command Open class definition
class OpenClass : public Tango::Command
{
public:
	OpenClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	OpenClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~OpenClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Mks651d *>(dev))->is_Open_allowed(any);}
};

//	Command Close class definition
class CloseClass : public Tango::Command
{
public:
	CloseClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	CloseClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~CloseClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Mks651d *>(dev))->is_Close_allowed(any);}
};

//	Command Stop class definition
class StopClass : public Tango::Command
{
public:
	StopClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	StopClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~StopClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Mks651d *>(dev))->is_Stop_allowed(any);}
};

//	Command SelectSP class definition
class SelectSPClass : public Tango::Command
{
public:
	SelectSPClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	SelectSPClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~SelectSPClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Mks651d *>(dev))->is_SelectSP_allowed(any);}
};

//	Command ReadSPLevel class definition
class ReadSPLevelClass : public Tango::Command
{
public:
	ReadSPLevelClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ReadSPLevelClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ReadSPLevelClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Mks651d *>(dev))->is_ReadSPLevel_allowed(any);}
};

//	Command WriteSPLevel class definition
class WriteSPLevelClass : public Tango::Command
{
public:
	WriteSPLevelClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	WriteSPLevelClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~WriteSPLevelClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Mks651d *>(dev))->is_WriteSPLevel_allowed(any);}
};

//	Command ReadSPType class definition
class ReadSPTypeClass : public Tango::Command
{
public:
	ReadSPTypeClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ReadSPTypeClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ReadSPTypeClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Mks651d *>(dev))->is_ReadSPType_allowed(any);}
};

//	Command WriteSPType class definition
class WriteSPTypeClass : public Tango::Command
{
public:
	WriteSPTypeClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	WriteSPTypeClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~WriteSPTypeClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Mks651d *>(dev))->is_WriteSPType_allowed(any);}
};

//	Command ReadSoftStart class definition
class ReadSoftStartClass : public Tango::Command
{
public:
	ReadSoftStartClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ReadSoftStartClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ReadSoftStartClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Mks651d *>(dev))->is_ReadSoftStart_allowed(any);}
};

//	Command WriteSoftStart class definition
class WriteSoftStartClass : public Tango::Command
{
public:
	WriteSoftStartClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	WriteSoftStartClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~WriteSoftStartClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Mks651d *>(dev))->is_WriteSoftStart_allowed(any);}
};

//	Command ReadSPGain class definition
class ReadSPGainClass : public Tango::Command
{
public:
	ReadSPGainClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ReadSPGainClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ReadSPGainClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Mks651d *>(dev))->is_ReadSPGain_allowed(any);}
};

//	Command WriteSPGain class definition
class WriteSPGainClass : public Tango::Command
{
public:
	WriteSPGainClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	WriteSPGainClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~WriteSPGainClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Mks651d *>(dev))->is_WriteSPGain_allowed(any);}
};

//	Command ReadSPLead class definition
class ReadSPLeadClass : public Tango::Command
{
public:
	ReadSPLeadClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ReadSPLeadClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ReadSPLeadClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Mks651d *>(dev))->is_ReadSPLead_allowed(any);}
};

//	Command WriteSPLead class definition
class WriteSPLeadClass : public Tango::Command
{
public:
	WriteSPLeadClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	WriteSPLeadClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~WriteSPLeadClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Mks651d *>(dev))->is_WriteSPLead_allowed(any);}
};

//	Command ReadThreshold class definition
class ReadThresholdClass : public Tango::Command
{
public:
	ReadThresholdClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ReadThresholdClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ReadThresholdClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Mks651d *>(dev))->is_ReadThreshold_allowed(any);}
};

//	Command WriteThreshold class definition
class WriteThresholdClass : public Tango::Command
{
public:
	WriteThresholdClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	WriteThresholdClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~WriteThresholdClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Mks651d *>(dev))->is_WriteThreshold_allowed(any);}
};

//	Command StartLearning class definition
class StartLearningClass : public Tango::Command
{
public:
	StartLearningClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	StartLearningClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~StartLearningClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Mks651d *>(dev))->is_StartLearning_allowed(any);}
};

//	Command StopLearning class definition
class StopLearningClass : public Tango::Command
{
public:
	StopLearningClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	StopLearningClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~StopLearningClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Mks651d *>(dev))->is_StopLearning_allowed(any);}
};

//	Command LearnAnalog class definition
class LearnAnalogClass : public Tango::Command
{
public:
	LearnAnalogClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	LearnAnalogClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~LearnAnalogClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Mks651d *>(dev))->is_LearnAnalog_allowed(any);}
};

//	Command CalibrateAdc class definition
class CalibrateAdcClass : public Tango::Command
{
public:
	CalibrateAdcClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	CalibrateAdcClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~CalibrateAdcClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Mks651d *>(dev))->is_CalibrateAdc_allowed(any);}
};

//	Command ZeroSensor class definition
class ZeroSensorClass : public Tango::Command
{
public:
	ZeroSensorClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ZeroSensorClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ZeroSensorClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Mks651d *>(dev))->is_ZeroSensor_allowed(any);}
};

//	Command RemoveZero class definition
class RemoveZeroClass : public Tango::Command
{
public:
	RemoveZeroClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	RemoveZeroClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~RemoveZeroClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Mks651d *>(dev))->is_RemoveZero_allowed(any);}
};

//	Command SetZero class definition
class SetZeroClass : public Tango::Command
{
public:
	SetZeroClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	SetZeroClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~SetZeroClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Mks651d *>(dev))->is_SetZero_allowed(any);}
};

//	Command LearnZero class definition
class LearnZeroClass : public Tango::Command
{
public:
	LearnZeroClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	LearnZeroClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~LearnZeroClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Mks651d *>(dev))->is_LearnZero_allowed(any);}
};

//	Command DirectCommand class definition
class DirectCommandClass : public Tango::Command
{
public:
	DirectCommandClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	DirectCommandClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~DirectCommandClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Mks651d *>(dev))->is_DirectCommand_allowed(any);}
};





/**
 *	The TemplateDevServClass singleton definition
 */

class
#ifdef _TG_WINDOWS_
	__declspec(dllexport)
#endif
	Mks651dClass : public Tango::DeviceClass
{
	/*----- PROTECTED REGION ID(Mks651d::Additionnal DServer data members) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	Mks651d::Additionnal DServer data members



public:
//	write class properties data members
	Tango::DbData	cl_prop;
	Tango::DbData	cl_def_prop;
	Tango::DbData	dev_def_prop;

//	Method prototypes
	static Mks651dClass *init(const char *);
	static Mks651dClass *instance();
	~Mks651dClass();
	Tango::DbDatum	get_class_property(string &);
	Tango::DbDatum	get_default_device_property(string &);
	Tango::DbDatum	get_default_class_property(string &);
	
protected:
	Mks651dClass(string &);
	static Mks651dClass *_instance;
	void command_factory();
	void attribute_factory(vector<Tango::Attr *> &);
	void write_class_property();
	void set_default_property();
	void get_class_property();
	string get_cvstag();
	string get_cvsroot();

private:
	void device_factory(const Tango::DevVarStringArray *);
	void create_static_attribute_list(vector<Tango::Attr *> &);
	void erase_dynamic_attributes(const Tango::DevVarStringArray *,vector<Tango::Attr *> &);
	vector<string>	defaultAttList;


};

}	//	namespace

#endif	//	MKS651DCLASS_H

